using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class ImageEffect : MonoBehaviour
{
	public virtual void UpdateRT(int width, int height)
	{
		
	}

	public void OnWindowResized(int width, int height)
	{
		UpdateRT(width, height);
	}

	public void OnStateChanged()
	{
		UpdateRT(Screen.width, Screen.height);
	}
}
