using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class Player : MonoBehaviour
{

	public GamePanels GP_;
	public int gameOver = 0;
	public int pauseGame = 0;
	public int its_player;
	//										
	public float speed_holder;// = 2f;// 
	public float x_axis = 0f;
	public float z_axis = 0f;
	public float d_axis; //= 13;// 


	//										
	public int record_score;
	public int cur_score = 0;
	public int cur_redBoll;
	public GameObject obj_0;
	public GameObject obj_1;
	public GameObject obj_2;
	public GameObject obj_3;
	public GameObject obj_4;
	public GameObject obj_5;
	//										
	public Text txt_score;
	//
	public GameObject hole_R_U;
	public GameObject hole_R_D;
	public GameObject hole_U_U;
	public GameObject hole_D_D;
	public GameObject hole_L_U;
	public GameObject hole_L_D;
	//
	public Prefab prefab_red;
	public Prefab prefab_blcak;
	public Prefab prefab_white;
	public Prefab prefab_yellw;
	public Prefab prefab_pink;
	public Prefab prefab_blue;
	public int rnd_color;
	//
	public Transform point_red;
	public Transform point_blcak;
	public Transform point_white;
	public Transform point_color;

	public AudioSource as_;
	public AudioClip ac_holeRed;
	public AudioClip ac_holeColor;
	


	void Start()
	{
		Time.timeScale = 1f;
		cur_redBoll = 0;
		F_hideRedInStrart();

		its_player = 0;
		//
		record_score = PlayerPrefs.GetInt("record_score");
		txt_score.text = ("Record score: " + record_score + " Score: " + cur_score);
		F_setReady();
	}
	
	void FixedUpdate()
    {
        if (its_player == 1) {
			if (pauseGame == 0)
			{
				//move horizontal
				if (Input.GetKey(ScanCode.A) || (Input.GetKey(ScanCode.LeftArrow)))
				{
					if (x_axis < d_axis)
					{
						x_axis += Time.deltaTime * speed_holder;
					}

				}
				if (Input.GetKey(ScanCode.D) || (Input.GetKey(ScanCode.RightArrow)))
				{
					if (x_axis > -d_axis)
					{
						x_axis -= Time.deltaTime * speed_holder;
					}
				}
				//move verticals
				if (Input.GetKey(ScanCode.W) || (Input.GetKey(ScanCode.UpArrow)))
				{
					if (z_axis < d_axis)
					{
						z_axis += Time.deltaTime * speed_holder;
					}
				}
				if (Input.GetKey(ScanCode.S) || (Input.GetKey(ScanCode.DownArrow)))
				{
					if (z_axis > -d_axis)
					{
						z_axis -= Time.deltaTime * speed_holder;
					}


				}
				if (z_axis > d_axis)
				{

					z_axis = d_axis;

				}
				if (z_axis < -d_axis)
				{

					z_axis = -d_axis;

				}

				gameObject.GetComponent<Rigidbody>().rotation = Quaternion.Euler(x_axis, 0f, z_axis);
			}





		}// if (pauseGame == 0 && gameOver == 0)

		if (pauseGame == 0)
		{
			if (Input.GetKey(ScanCode.Escape))
			{
				F_setPause();
			}

		}


	}//end update																																																
	public void F_ViewHigfht() 
	{
		//scores																			

			if(record_score	<cur_score)
			{
				record_score = cur_score;
				PlayerPrefs.SetInt("record_score", record_score);
			}
		
			//* 

			
			txt_score.text = ("Record score: " + record_score + " Score: " + cur_score);

	}
	
	public void F_setReady() 
	{
		//   
	//	gameObject.transform.rotation = Quaternion.Euler(0f,0f,0f);
	}


	public void F_setGameOver() 
	{
		gameOver = 1;
		GameObject W_boll = GameObject.Find("BoLL_white");
		W_boll.GetComponent<WhiteBoll>().enabled = false;
		GP_.F_callGameOver();


	}

	public void F_setPause()
	{

		pauseGame = 1;
		GameObject W_boll = GameObject.Find("BoLL_white");
		W_boll.GetComponent<WhiteBoll>().enabled = false;

		GP_.F_callPause();


	}
	public void F_setResume()
	{
		GameObject W_boll = GameObject.Find("BoLL_white");
		W_boll.GetComponent<WhiteBoll>().enabled = true;
		pauseGame = 0;
	}

	public void F_deductScore()
	{
		as_.audioClip = ac_holeRed;
		as_.Play();
		cur_redBoll++;

		if (cur_redBoll == 1) 
		{
			obj_0.enabled = false;
			obj_1.enabled = true;
			obj_2.enabled = false;
			obj_3.enabled = false;
			obj_4.enabled = false;
			obj_5.enabled = false;
		}
		if (cur_redBoll == 2)
		{
			obj_0.enabled = false;
			obj_1.enabled = false;
			obj_2.enabled = true;
			obj_3.enabled = false;
			obj_4.enabled = false;
			obj_5.enabled = false;
		}

		if (cur_redBoll == 3)
		{
			obj_0.enabled = false;
			obj_1.enabled = false;
			obj_2.enabled = false;
			obj_3.enabled = true;
			obj_4.enabled = false;
			obj_5.enabled = false;
		}
		if (cur_redBoll == 4)
		{
			obj_0.enabled = false;
			obj_1.enabled = false;
			obj_2.enabled = false;
			obj_3.enabled = false;
			obj_4.enabled = true;
			obj_5.enabled = false;
		}
		if (cur_redBoll == 5)
		{
			obj_0.enabled = false;
			obj_1.enabled = false;
			obj_2.enabled = false;
			obj_3.enabled = false;
			obj_4.enabled = false;
			obj_5.enabled = true;
			F_setGameOver();
		}
		//cur_score -= deduct;
		//F_ViewHigfht();
	}
	public void F_addScore(int add)
	{
		as_.audioClip = ac_holeColor;
		as_.Play();
		cur_score += add;
		F_ViewHigfht();
	}

	public void F_createRed()
	{

		prefab_red.Instantiate(point_red.position, Quaternion.identity);
	}
	public void F_createCOLOR()
	{
		rnd_color = FalcoEngine.Random.Range(0,3);
		if (rnd_color == 0) 
		{
			prefab_yellw.Instantiate(point_color.position, Quaternion.identity);
		}
		if (rnd_color == 1)
		{
			prefab_pink.Instantiate(point_color.position, Quaternion.identity);
		}
		if (rnd_color == 2)
		{
			prefab_blue.Instantiate(point_color.position, Quaternion.identity);
		}


	}
	public void F_createWhite()
	{
		prefab_white.Instantiate(point_white.position, Quaternion.identity);
	}

	public void F_createBlack()
	{
		prefab_blcak.Instantiate(point_blcak.position, Quaternion.identity);
	}

	public void F_hideRedInStrart()
	{
		obj_0.enabled = true;
		obj_1.enabled = false;
		obj_2.enabled = false;
		obj_3.enabled = false;
		obj_4.enabled = false;
		obj_5.enabled = false;

	}

}
